AddonManage = LibStub("AceAddon-3.0"):NewAddon("AddonManage")
local AceGUI = LibStub("AceGUI-3.0")
local AddonManage = AddonManage
local function uncolorstring(s)
	s = string.gsub(s, "|cff%S%S%S%S%S%S", "")
	s = string.gsub(s, "|r", "")
	return s
end
function AddonManage:OnInitialize()
	local at, ud, dp, nums, tt = {}, {}, {}, {}, {}
	for num_addon=1, GetNumAddOns() do
		local fold, title, notes, enabled, loadable, reason = GetAddOnInfo(num_addon)
		if not loadable and ((reason == "DEP_DISABLED") or (reason == "DISABLED")) then
			loadable = true
			reason = nil
		end
		local deps = {GetAddOnDependencies(num_addon)}
		for n, addon in ipairs(deps) do
			dp[addon] = dp[addon] or {}
			tinsert(dp[addon], fold)
		end
		tinsert(at, {f=fold, t=title, n=notes, e=enabled, l=loadable, r=reason, i=num_addon, d=deps})
		tt[fold] = title
		ud[title] = false
	end
	--table.sort(at, function(a,b) if a.e == b.e then return a.t:lower() < b.t:lower() else return a.e and true or false end end)
	table.sort(at, function(a,b) return a.t:lower() < b.t:lower() end)
	for num, data in ipairs(at) do
		nums[data.f] = num
	end
	self.addons = at
	self.update = ud
	self.rdeps = dp
	self.nums = nums
	self.titles = tt
	local config = AceGUI:Create("Frame")
	config:Hide()
	self.config = config
	config:SetTitle("AddonManage r2")
	function config:CheckDeps(t)
		if not AddonManage.rdeps[t] then return end
		for _, title in ipairs(AddonManage.rdeps[t]) do
			print(title, AddonManage.nums[title])
			--this is for debug since i only render the first 50
			if self.groups[AddonManage.nums[title]] then
				self.groups[AddonManage.nums[title]]:CheckLoadable()
			end
		end
	end
	config:SetLayout("List")
	local scrollframe = AceGUI:Create("ScrollFrame")
	config:AddChild(scrollframe)
	scrollframe:SetFullWidth(true)
	scrollframe:SetFullHeight(true)
	scrollframe:SetLayout("List")
	config.groups = {}
	local a = CreateFrame("Frame")
	a.n = 0
	a.t = 0
	local numaddons = #at
	--for n, data in ipairs(at) do
	local loadfunc = function(self, elapsed)
		if InCombatLockdown() then return end
		self.t = self.t+elapsed
		if self.t < (config.frame:IsShown() and 0.01 or 1) then return end
		self.t  = 0
		self.n = a.n+1
		local n = self.n
		local data = at[n]
		if data and (n <= 50) then
			local t ="Loading "..(math.floor((n/numaddons)*1000)/10).."% complete."
			if t ~= self.tc then
				config:SetStatusText(t)
				self.tc = t
			end
			local group = AceGUI:Create("SimpleGroup")
			group:SetLayout("Flow")
			group:SetFullWidth(true)
			local name = AceGUI:Create("InteractiveLabel")
			name:SetText(uncolorstring(data.t))
			name:SetColor(1,1,1)
			name:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			name:SetCallback("OnEnter", function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("TOPLEFT", self.frame, "BOTTOMLEFT")
				GameTooltip:ClearLines()
				GameTooltip:AddLine(data.t)
				GameTooltip:AddLine(data.n)
				GameTooltip:Show()
			end)
			name:SetCallback("OnLeave", function() GameTooltip:Hide() end)
			name:SetRelativeWidth(0.49)
			group:AddChild(name)
			local toggle = AceGUI:Create("InteractiveLabel")
			toggle:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			function group:IsLoadable()
				if not data.l then
					return false, _G["ADDON_"..data.r]
				end
				for i,k in ipairs(data.d) do
					if k:find("Blizzard_%S+") then
					elseif (AddonManage.addons[AddonManage.nums[k]].e and (not AddonManage.update[AddonManage.titles[k]])) then
					elseif ((not AddonManage.addons[AddonManage.nums[k]].e) and AddonManage.update[AddonManage.titles[k]]) then
					else
						return false, ADDON_DEP_DISABLED
					end
				end
				return true
			end
			function group:CheckLoadable()
				if AddonManage.update[data.t] then
					if data.e then
						toggle:SetText("DISABLE")
						toggle:SetColor(1,0,0)
					else
						toggle:SetText("ENABLE")
						toggle:SetColor(0,1,0)
					end
				else
					if data.e then
						toggle:SetText("ENABLED")
						toggle:SetColor(0,0.5,0)
					else
						toggle:SetText("DISABLED")
						toggle:SetColor(0.5,0,0)
					end
				end
				local isLoadable, loadError = self:IsLoadable()
				if isLoadable then
					toggle:SetCallback("OnClick", function()
						AddonManage.update[data.t] = not AddonManage.update[data.t]
						config:CheckDeps(data.t)
						group:CheckLoadable()
						config:UpdateStatusText()
					end)
					toggle:SetCallback("OnEnter", nil)
					toggle:SetCallback("OnLeave", nil)
				else
					toggle:SetCallback("OnClick", nil)
					toggle:SetCallback("OnEnter", function(self)
						GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
						GameTooltip:ClearAllPoints()
						GameTooltip:SetPoint("TOPLEFT", self.frame, "BOTTOMLEFT")
						GameTooltip:ClearLines()
						GameTooltip:AddLine("Unloadable")
						GameTooltip:AddLine(loadError)
						GameTooltip:Show()
					end)
					toggle:SetCallback("OnLeave", function() GameTooltip:Hide() end)
					toggle:SetColor(0.2,0.2,0.2)
				end
			end
			name:SetCallback("OnClick", function()
				toggle.frame:GetScript("OnMouseDown")(toggle.frame, "LeftButton")
			end)
			toggle:SetRelativeWidth(0.49)
			group:AddChild(toggle)
			local filler = AceGUI:Create("Label")
			filler:SetHeight(20)
			filler:SetFullWidth(true)
			filler:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			filler:SetText("")
			group:AddChild(filler)
			scrollframe:AddChild(group)
			config.groups[n] = group
		else
			for num, g in ipairs(config.groups) do
				g:CheckLoadable()
			end
			local applygroup = AceGUI:Create("InlineGroup")
			applygroup:SetFullWidth(true)
			applygroup:SetLayout("Flow")
			local applyfiller = AceGUI:Create("Label")
			applyfiller:SetFont("FONTS\\FRIZQT__.TTF", 12, "OUTLINE")
			applyfiller:SetRelativeWidth(0.7)
			applyfiller:SetText("")
			applygroup:AddChild(applyfiller)
			local apply = AceGUI:Create("Button")
			apply:SetText("Apply changes")
			apply:SetRelativeWidth(0.3)
			apply:SetCallback("OnClick", function() for i,k in ipairs(AddonManage.addons) do if AddonManage.update[k.t] then if k.e then DisableAddOn(k.i) else EnableAddOn(k.i) end end end ReloadUI() end)
			apply:SetHeight(30)
			applygroup:AddChild(apply)
			config:AddChild(applygroup)
			function config:UpdateStatusText()
				local enable, disable = 0,0
				for n,k in ipairs(AddonManage.addons) do
					if AddonManage.update[k.t] then
						if k.e then
							disable = disable+1
						else
							enable = enable+1
						end
					end
				end
				self:SetStatusText((enable+disable).." pending changes ("..enable.." enables, "..disable.." disables)")
				if (enable+disable) > 0 then
					applygroup.frame:Show()
					apply:SetDisabled(false)
				else
					applygroup.frame:Hide()
					apply:SetDisabled(true)
				end
			end
			config:UpdateStatusText()
			self:SetScript("OnUpdate", nil)
			self.loadfin = true
		end
	end
	a:SetScript("OnUpdate", loadfunc)
	self.loadfunc = loadfunc
	self.updateframe = a
	config:SetCallback("OnClose", function(self) self:Hide() --[[a:SetScript("OnUpdate", nil)--]] end)
		--if n > 50 then break end
	--end
	SlashCmdList["ADDONMANAGE"] = function() AddonManage.config:Show() end
	SLASH_ADDONMANAGE1 = "/addons"
	SLASH_ADDONMANAGE2 = "/addon"
	SLASH_ADDONMANAGE3 = "/addonmanage"
end